## rustc-1.81 1.81.0+dfsg0ubuntu1

=== tests/run-make/c-unwind-abi-catch-lib-panic/Makefile ===
# Exercise unwinding a panic. This catches a panic across an FFI boundary and downcasts it into an integer. The Rust code that panics is in a separate crate.
# See https://github.com/rust-lang/rust/commit/baf227ea0c1e07fc54395a51e4b3881d701180cb

# ignore-cross-compile
# needs-unwind
include ../tools.mk

all: archive
	# Compile `main.rs`, which will link into our library, and run it.
	$(RUSTC) main.rs
	$(call RUN,main)

ifdef IS_MSVC
archive: add.o panic.o
	# Now, create an archive using these two objects.
	$(AR) crus $(TMPDIR)/add.lib $(TMPDIR)/add.o $(TMPDIR)/panic.o
else
archive: add.o panic.o
	# Now, create an archive using these two objects.
	$(AR) crus $(TMPDIR)/libadd.a $(TMPDIR)/add.o $(TMPDIR)/panic.o
endif

# Compile `panic.rs` into an object file.
#
# Note that we invoke `rustc` directly, so we may emit an object rather
# than an archive. We'll do that later.
panic.o:
	$(BARE_RUSTC) $(RUSTFLAGS)  \
		--out-dir $(TMPDIR) \
		--emit=obj panic.rs

# Compile `add.c` into an object file.
add.o:
	$(call COMPILE_OBJ,$(TMPDIR)/add.o,add.c)

=== tests/run-make/compiler-lookup-paths-2/Makefile ===
# This test checks that extern crate declarations in Cargo without a corresponding declaration in the manifest of a dependency are NOT allowed.
# See https://github.com/rust-lang/rust/pull/21113

include ../tools.mk

all:
	mkdir -p $(TMPDIR)/a $(TMPDIR)/b
	$(RUSTC) a.rs && mv $(TMPDIR)/liba.rlib $(TMPDIR)/a
	$(RUSTC) b.rs -L $(TMPDIR)/a && mv $(TMPDIR)/libb.rlib $(TMPDIR)/b
	$(RUSTC) c.rs -L crate=$(TMPDIR)/b -L dependency=$(TMPDIR)/a \
		&& exit 1 || exit 0

=== tests/run-make/compiler-rt-works-on-mingw/Makefile ===
include ../tools.mk

# only-windows-gnu

all:
	$(CXX) foo.cpp -c -o $(TMPDIR)/foo.o
	$(AR) crus $(TMPDIR)/libfoo.a $(TMPDIR)/foo.o
	$(RUSTC) foo.rs -lfoo -lstdc++
	$(call RUN,foo)

=== tests/run-make/cross-lang-lto-clang/Makefile ===
# needs-force-clang-based-tests

# This test makes sure that cross-language inlining actually works by checking
# the generated machine code.

include ../tools.mk

all: cpp-executable rust-executable

cpp-executable:
	$(RUSTC) -Clinker-plugin-lto=on -o $(TMPDIR)/librustlib-xlto.a -Copt-level=2 -Ccodegen-units=1 ./rustlib.rs
	$(CLANG) -flto=thin -fuse-ld=lld -L $(TMPDIR) -lrustlib-xlto -o $(TMPDIR)/cmain ./cmain.c -O3
	# Make sure we don't find a call instruction to the function we expect to
	# always be inlined.
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/cmain | $(CGREP) -v -e "call.*rust_always_inlined"
	# As a sanity check, make sure we do find a call instruction to a
	# non-inlined function
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/cmain | $(CGREP) -e "call.*rust_never_inlined"

rust-executable:
	$(CLANG) ./clib.c -flto=thin -c -o $(TMPDIR)/clib.o -O2
	(cd $(TMPDIR); $(AR) crus ./libxyz.a ./clib.o)
	$(RUSTC) -Clinker-plugin-lto=on -L$(TMPDIR) -Copt-level=2 -Clinker=$(CLANG) -Clink-arg=-fuse-ld=lld ./main.rs -o $(TMPDIR)/rsmain
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/rsmain | $(CGREP) -e "call.*c_never_inlined"
	"$(LLVM_BIN_DIR)"/llvm-objdump -d $(TMPDIR)/rsmain | $(CGREP) -v -e "call.*c_always_inlined"

=== tests/run-make/cross-lang-lto-pgo-smoketest/Makefile ===
# needs-force-clang-based-tests

# FIXME(#126180): This test doesn't actually run anywhere, because the only
# CI job that sets RUSTBUILD_FORCE_CLANG_BASED_TESTS runs very few tests.

# This test makes sure that cross-language inlining can be used in conjunction
# with profile-guided optimization. The test only tests that the whole workflow
# can be executed without anything crashing. It does not test whether PGO or
# xLTO have any specific effect on the generated code.

include ../tools.mk

COMMON_FLAGS=-Copt-level=3 -Ccodegen-units=1

# LLVM doesn't support instrumenting binaries that use SEH:
# https://bugs.llvm.org/show_bug.cgi?id=41279
#
# Things work fine with -Cpanic=abort though.
ifdef IS_MSVC
COMMON_FLAGS+= -Cpanic=abort
endif

all: cpp-executable rust-executable

cpp-executable:
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-generate="$(TMPDIR)"/cpp-profdata \
	         -o "$(TMPDIR)"/librustlib-xlto.a \
	         $(COMMON_FLAGS) \
	         ./rustlib.rs
	$(CLANG) -flto=thin \
	         -fprofile-generate="$(TMPDIR)"/cpp-profdata \
	         -fuse-ld=lld \
	         -L "$(TMPDIR)" \
	         -lrustlib-xlto \
	         -o "$(TMPDIR)"/cmain \
	         -O3 \
	         ./cmain.c
	$(TMPDIR)/cmain
	# Postprocess the profiling data so it can be used by the compiler
	"$(LLVM_BIN_DIR)"/llvm-profdata merge \
		-o "$(TMPDIR)"/cpp-profdata/merged.profdata \
		"$(TMPDIR)"/cpp-profdata/default_*.profraw
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-use="$(TMPDIR)"/cpp-profdata/merged.profdata \
	         -o "$(TMPDIR)"/librustlib-xlto.a \
	         $(COMMON_FLAGS) \
	         ./rustlib.rs
	$(CLANG) -flto=thin \
	         -fprofile-use="$(TMPDIR)"/cpp-profdata/merged.profdata \
	         -fuse-ld=lld \
	         -L "$(TMPDIR)" \
	         -lrustlib-xlto \
	         -o "$(TMPDIR)"/cmain \
	         -O3 \
	         ./cmain.c

rust-executable:
	exit
	$(CLANG) ./clib.c -fprofile-generate="$(TMPDIR)"/rs-profdata -flto=thin -c -o $(TMPDIR)/clib.o -O3
	(cd $(TMPDIR); $(AR) crus ./libxyz.a ./clib.o)
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-generate="$(TMPDIR)"/rs-profdata \
	         -L$(TMPDIR) \
	         $(COMMON_FLAGS) \
	         -Clinker=$(CLANG) \
	         -Clink-arg=-fuse-ld=lld \
	         -o $(TMPDIR)/rsmain \
	         ./main.rs
	$(TMPDIR)/rsmain
	# Postprocess the profiling data so it can be used by the compiler
	"$(LLVM_BIN_DIR)"/llvm-profdata merge \
		-o "$(TMPDIR)"/rs-profdata/merged.profdata \
		"$(TMPDIR)"/rs-profdata/default_*.profraw
	$(CLANG) ./clib.c \
	         -fprofile-use="$(TMPDIR)"/rs-profdata/merged.profdata \
	         -flto=thin \
	         -c \
	         -o $(TMPDIR)/clib.o \
	         -O3
	rm "$(TMPDIR)"/libxyz.a
	(cd $(TMPDIR); $(AR) crus ./libxyz.a ./clib.o)
	$(RUSTC) -Clinker-plugin-lto=on \
	         -Cprofile-use="$(TMPDIR)"/rs-profdata/merged.profdata \
	         -L$(TMPDIR) \
	         $(COMMON_FLAGS) \
	         -Clinker=$(CLANG) \
	         -Clink-arg=-fuse-ld=lld \
	         -o $(TMPDIR)/rsmain \
	         ./main.rs

=== tests/run-make/cross-lang-lto/Makefile ===

include ../tools.mk

# ignore windows due to libLLVM being present in PATH and the PATH and library path being the same
# (so fixing it is harder). See #57765 for context
ifndef IS_WINDOWS

# This test makes sure that the object files we generate are actually
# LLVM bitcode files (as used by linker LTO plugins) when compiling with
# -Clinker-plugin-lto.

# this only succeeds for bitcode files
ASSERT_IS_BITCODE_OBJ=("$(LLVM_BIN_DIR)"/llvm-bcanalyzer $(1))
EXTRACT_OBJS=(cd $(TMPDIR); rm -f ./*.o; "$(LLVM_BIN_DIR)"/llvm-ar x $(1))

BUILD_LIB=$(RUSTC) lib.rs -Copt-level=2 -Clinker-plugin-lto -Ccodegen-units=1
BUILD_EXE=$(RUSTC) main.rs -Copt-level=2 -Clinker-plugin-lto -Ccodegen-units=1 --emit=obj

all: staticlib staticlib-fat-lto staticlib-thin-lto rlib exe cdylib rdylib

staticlib: lib.rs
	$(BUILD_LIB) --crate-type=staticlib -o $(TMPDIR)/liblib.a
	$(call EXTRACT_OBJS, liblib.a)
	for file in $(TMPDIR)/liblib.*.rcgu.o; do $(call ASSERT_IS_BITCODE_OBJ, $$file); done

staticlib-fat-lto: lib.rs
	$(BUILD_LIB) --crate-type=staticlib -o $(TMPDIR)/liblib-fat-lto.a -Clto=fat
	$(call EXTRACT_OBJS, liblib-fat-lto.a)
	for file in $(TMPDIR)/liblib-fat-lto.*.rcgu.o; do $(call ASSERT_IS_BITCODE_OBJ, $$file); done

staticlib-thin-lto: lib.rs
	$(BUILD_LIB) --crate-type=staticlib -o $(TMPDIR)/liblib-thin-lto.a -Clto=thin
	$(call EXTRACT_OBJS, liblib-thin-lto.a)
	for file in $(TMPDIR)/liblib-thin-lto.*.rcgu.o; do $(call ASSERT_IS_BITCODE_OBJ, $$file); done

rlib: lib.rs
	$(BUILD_LIB) --crate-type=rlib -o $(TMPDIR)/liblib.rlib
	$(call EXTRACT_OBJS, liblib.rlib)
	for file in $(TMPDIR)/liblib.*.rcgu.o; do $(call ASSERT_IS_BITCODE_OBJ, $$file); done

cdylib: lib.rs
	$(BUILD_LIB) --crate-type=cdylib --emit=obj -o $(TMPDIR)/cdylib.o
	$(call ASSERT_IS_BITCODE_OBJ, $(TMPDIR)/cdylib.o)

rdylib: lib.rs
	$(BUILD_LIB) --crate-type=dylib --emit=obj -o $(TMPDIR)/rdylib.o
	$(call ASSERT_IS_BITCODE_OBJ, $(TMPDIR)/rdylib.o)

exe: lib.rs
	$(BUILD_EXE) -o $(TMPDIR)/exe.o
	$(call ASSERT_IS_BITCODE_OBJ, $(TMPDIR)/exe.o)

else

all:

endif

=== tests/run-make/dep-info/Makefile ===
include ../tools.mk

# ignore-windows
# ignore-freebsd
# FIXME: on windows `rustc --dep-info` produces Makefile dependency with
# windows native paths (e.g. `c:\path\to\libfoo.a`)
# but msys make seems to fail to recognize such paths, so test fails.

all:
	cp *.rs $(TMPDIR)
	$(RUSTC) --emit dep-info,link --crate-type=lib $(TMPDIR)/lib.rs
	sleep 2
	touch $(TMPDIR)/foo.rs
	-rm -f $(TMPDIR)/done
	$(MAKE) -drf Makefile.foo
	sleep 2
	rm $(TMPDIR)/done
	pwd
	$(MAKE) -drf Makefile.foo
	rm $(TMPDIR)/done && exit 1 || exit 0

	# When a source file is deleted `make` should still work
	rm $(TMPDIR)/bar.rs
	cp $(TMPDIR)/lib2.rs $(TMPDIR)/lib.rs
	$(MAKE) -drf Makefile.foo

=== tests/run-make/issue-47551/Makefile ===
# only-linux
# ignore-32bit

include ../tools.mk

all:
	# --target $(TARGET) ensures the right gcc flags are used for cross compilation
	$(RUSTC) --target $(TARGET) eh_frame-terminator.rs
	$(call RUN,eh_frame-terminator) | $(CGREP) '1122334455667788'
	objdump --dwarf=frames $(TMPDIR)/eh_frame-terminator | $(CGREP) 'ZERO terminator'

=== tests/run-make/issue-84395-lto-embed-bitcode/Makefile ===
# needs-force-clang-based-tests

# FIXME(#126180): This test doesn't actually run anywhere, because the only
# CI job that sets RUSTBUILD_FORCE_CLANG_BASED_TESTS runs very few tests.

# This test makes sure the embed bitcode in elf created with
# lto-embed-bitcode=optimized is valid llvm BC module.

include ../tools.mk

all:
	$(RUSTC) test.rs --target $(TARGET) -Clink-arg=-fuse-ld=lld -Clinker-plugin-lto -Clinker=$(CLANG) -Clink-arg=-Wl,--plugin-opt=-lto-embed-bitcode=optimized -Zemit-thin-lto=no
	$(LLVM_BIN_DIR)/objcopy --dump-section .llvmbc=$(TMPDIR)/test.bc $(TMPDIR)/test
	$(LLVM_BIN_DIR)/llvm-dis $(TMPDIR)/test.bc

=== tests/run-make/link-framework/Makefile ===
# only-apple
#
# Check that linking to a framework actually makes it to the linker.

include ../tools.mk

all:
	$(RUSTC) dep-link-framework.rs
	$(RUSTC) dep-link-weak-framework.rs

	$(RUSTC) empty.rs
	otool -L $(TMPDIR)/no-link | $(CGREP) -v CoreFoundation

	$(RUSTC) link-framework.rs
	otool -L $(TMPDIR)/link-framework | $(CGREP) CoreFoundation | $(CGREP) -v weak

	$(RUSTC) link-weak-framework.rs
	otool -L $(TMPDIR)/link-weak-framework | $(CGREP) CoreFoundation | $(CGREP) weak

# When linking the framework both normally, and weakly, the weak linking takes preference

	$(RUSTC) link-both.rs
	otool -L $(TMPDIR)/link-both | $(CGREP) CoreFoundation | $(CGREP) weak

=== tests/run-make/long-linker-command-lines/Makefile ===
# ignore-cross-compile
include ../tools.mk

export LD_LIBRARY_PATH := $(HOST_RPATH_DIR)

all:
	$(RUSTC) foo.rs -g -O
	RUSTC="$(RUSTC_ORIGINAL)" $(call RUN,foo)

=== tests/run-make/no-duplicate-libs/Makefile ===
# ignore-cross-compile
include ../tools.mk

ifdef IS_MSVC
# FIXME(#27979)
all:
else
all: $(call STATICLIB,foo) $(call STATICLIB,bar)
	$(RUSTC) main.rs
	$(call RUN,main)
endif

=== debian/control ===
Source: rustc-1.81
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dh-cargo (>= 28ubuntu1~),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo-1.80 | cargo-1.81 <!pkg.rustc.dlstage0>,
 rustc-1.80 | rustc-1.81 <!pkg.rustc.dlstage0>,
 llvm-18-dev:native,
 llvm-18-tools:native,
 libclang-rt-18-dev (>= 1:18.1.2),
 libclang-common-18-dev (>= 1:18.1.2),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkgconf,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# used by cargo
 bash-completion,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libssh2-1-dev,
 libgit2-dev (>= 1.9.0~~),
 libgit2-dev (<< 1.10~~),
 libhttp-parser-dev,
 libsqlite3-dev,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-18:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.6.2
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
RUST_PREV_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)-1}')
RUST_NEXT_VERSION=$(shell echo '$(RUST_LONG_VERSION)' | awk 'BEGIN{FS="."} {print $$1"."($$2)+1}')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
# needed for cross-compilation to avoid passing host CFLAGS to the BUILD
# compiler
export TARGET_CFLAGS = $(CFLAGS)
export TARGET_CXXFLAGS = $(CXXFLAGS)
export TARGET_CPPFLAGS = $(CPPFLAGS)
export TARGET_LDFLAGS = $(LDFLAGS)
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION
export RUST_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 18
OLD_LLVM_VERSION = $(shell echo "$$(($(LLVM_VERSION)-1))")
# used by the upstream profiler build script
CLANG_RT_TRIPLE := $(shell llvm-config-$(LLVM_VERSION) --host-target)
LLVM_PROFILER_RT_LIB = /usr/lib/clang/$(LLVM_VERSION)/lib/$(CLANG_RT_TRIPLE)/libclang_rt.profile.a
ifneq ($(wildcard $(LLVM_PROFILER_RT_LIB)),)
# Clang per-target layout
export LLVM_PROFILER_RT_LIB := /../../$(LLVM_PROFILER_RT_LIB)
else
# Clang legacy layout
CLANG_RT_ARCH := $(shell echo '$(CLANG_RT_TRIPLE)' | cut -f1 -d-)
ifeq ($(DEB_HOST_ARCH),armhf)
CLANG_RT_ARCH := armhf
endif
export LLVM_PROFILER_RT_LIB := /../../usr/lib/clang/$(LLVM_VERSION)/lib/linux/libclang_rt.profile-$(CLANG_RT_ARCH).a
endif
# Cargo-specific flags
export LIBSSH2_SYS_USE_PKG_CONFIG=1
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

# autopkgtest-related logic
ifneq (,$(RUST_TEST_SELFBUILD))
RUST_BOOTSTRAP_DIR = /usr/lib/rust-$(RUST_VERSION)
endif

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_BOOTSTRAP_DIR))
        RUST_LIBRARY_PATH := $(RUST_BOOTSTRAP_DIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_BOOTSTRAP_DIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/bootstrap/__pycache__ \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

# List generated files
FILES_TO_PRECONFIGURE := $(wildcard debian/*.in)
FILES_TO_PRECONFIGURE_OUT := $(subst X.Y,$(RUST_VERSION),\
  $(filter-out debian/control,\
    $(patsubst %.in,%,$(FILES_TO_PRECONFIGURE))\
  )\
)
DEFINED_SRC_NAME = $(shell dpkg-parsechangelog -S Source)
DEFINED_SRC_VERSION = $(shell cut -f1 -d' ' < $(CURDIR)/version)

%:

## rustc-1.81 1.81.0+dfsg0ubuntu1-0ubuntu1.24.04trisquel0

=== debian/changelog ===
rustc-1.81 (1.81.0+dfsg0ubuntu1-0ubuntu1.24.04trisquel0) ecne-backports; urgency=medium

  * Adding package as a dependency for newer abrowser releases.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 24 May 2025 18:57:36 +0000

rustc-1.81 (1.81.0+dfsg0ubuntu1-0ubuntu1.24.04) noble; urgency=medium

  * Backport to Noble (LP: #2080415)
    - d/p/ubuntu/ubuntu-libgit2-downgrade.patch: restore the patch.

 -- Zixing Liu <zixing.liu@canonical.com>  Thu, 06 Mar 2025 05:43:11 -0700

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: rustc-1.81
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
@@ -33,8 +33,8 @@
  bash-completion,
  libcurl4-gnutls-dev | libcurl4-openssl-dev,
  libssh2-1-dev,
- libgit2-dev (>= 1.9.0~~),
- libgit2-dev (<< 1.10~~),
+ libgit2-dev (>= 1.7.0),
+ libgit2-dev (<< 1.8~~),
  libhttp-parser-dev,
  libsqlite3-dev,
 # test dependencies:
